#include <stdio.h>
#include <string.h>
#include <stdlib.h>


#define MAXIM 1500 /* Màxima llargada d'un títol */

typedef struct
 {
   int year;
   char* name;
 } Registre;


typedef struct

 {

   int total;
   Registre *regs;

 } AlgoAdecuado;



int LeerDiscos( char* NomFichero, AlgoAdecuado* A ) {

 FILE* f;

 int i,err;
 char tmp[MAXIM];

 f = fopen( NomFichero, "r" );

 if (f == NULL) {

   fprintf(stderr,"No s'ha pogut obrir el fitxer %s.\n", NomFichero );

   return 1;

 }



 /* Recuperem el total de registres */

 err = fscanf( f, "%d%*c", &A->total );
 if (err == 0 || err == EOF) {
   fprintf(stderr, "Format del fitxer incorrecte.\n");
   return 1;

 }
 /* Reservem memoria per als registres */
 A->regs = malloc (A->total*sizeof(Registre));
 if (A->regs == NULL) {
   perror("Problem allocating memory\n");
   return 1;
 }


 for (i=0; i< A->total; i++) {

   err = fscanf( f, "%d%*c%[^\n]%*c", &A->regs[i].year, tmp );
   if (err == 0 || err == EOF){
     fprintf(stderr,"Fitxer defectuos.\n");
     return 1;
   }
   /* Alliberem memòria per al titol */
   A->regs[i].name = malloc(sizeof(char)*strlen(tmp));
   if (A->regs[i].name == NULL) {
     perror("Problem allocating memory\n");
     return 1;
   }
   strcpy(A->regs[i].name,tmp);

 }
 return 0;

}

void ImprimirAlgoAdecuado( AlgoAdecuado *A) {
 int i;
 printf("Total de registres existents: %d.\n",A->total);
 printf("Any\t\tTítol\n");
 for (i=0;i<40;i++)
   printf("-");
 printf("\n");
 for (i = 0; i < A->total; i++) {
   printf( "%d\t\t%s\n",A->regs[i].year,A->regs[i].name );
 }
}

int ImprimirFitxer( AlgoAdecuado *A ) {
 int i, err;
 FILE* f;
 f = fopen ("Salida.txt", "w");
 if ( f == NULL ) {
   fprintf(stderr, "No s'ha pogut obrir el fitxer 'Salida.txt'\n");
   return 1;
 }
 for (i = 0; i < A->total; i++) {
   if (A->regs[i].year == 2000)
     err = fprintf( f, "%d\t%s\n",A->regs[i].year,A->regs[i].name );
     if (!(err > 0)) {
       perror("Error d'escriptura en el fitxer 'Salida.txt'\n");
       fclose(f);
       return 1;
     }
 }
 fclose(f);
 return 0;
}


int main( int argc, char* argv[] ) {
 AlgoAdecuado algo;
 if (LeerDiscos("Discos.txt",&algo)){
   fprintf(stderr, "Error de lectura.\n");
   return 1;
 }

 ImprimirAlgoAdecuado(&algo);

 if (ImprimirFitxer(&algo)){
   fprintf(stderr, "Error d'impressio.\n");
   return 1;
 }
 return 0;
}

